



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SQL语法集锦一：SQL语句实现表的横向聚合</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SQL语法集锦一：SQL语句实现表的横向聚合</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 21:37:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文转载：<a href="http://www.cnblogs.com/lxblog/archive/2012/09/29/2708128.html" rel="external nofollow noreferrer">http://www.cnblogs.com/lxblog/archive/2012/09/29/2708128.html</a></p>
<p>问题描述：<br />假如有一表结构和数据如下：</p>
<table>
<tbody>
<tr>
<td>C1</td>
<td>C2</td>
<td>C3</td>
<td>C4</td>
<td>C5</td>
</tr>
<tr>
<td>1</td>
<td>2</td>
<td>6</td>
<td>3</td>
<td>4</td>
</tr>
<tr>
<td>2</td>
<td>2</td>
<td>3</td>
<td>4</td>
<td>5</td>
</tr>
<tr>
<td>0</td>
<td>3</td>
<td>6</td>
<td>2</td>
<td>8</td>
</tr>
</tbody>
</table>
<p>经过sql查询后输出的结果集为：(字段后面增加聚合[最大值] [最小值] [&gt;=5的值个数])</p>
<table>
<tbody>
<tr>
<td>C1</td>
<td>C2</td>
<td>C3</td>
<td>C4</td>
<td>C5</td>
<td>Max</td>
<td>Min</td>
<td>Count(&gt;=5)</td>
</tr>
<tr>
<td>1</td>
<td>2</td>
<td>6</td>
<td>3</td>
<td>4</td>
<td>6</td>
<td>1</td>
<td>1</td>
</tr>
<tr>
<td>2</td>
<td>2</td>
<td>3</td>
<td>4</td>
<td>5</td>
<td>5</td>
<td>2</td>
<td>1</td>
</tr>
<tr>
<td>0</td>
<td>3</td>
<td>6</td>
<td>2</td>
<td>8</td>
<td>8</td>
<td>2</td>
<td>2</td>
</tr>
</tbody>
</table>
<p>实现该结果的SQL 脚本如下:</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">/*<br />
  作    者：&lt;Rising_Sun&gt;<br />
  创建日期：&lt;2012-9-29&gt;<br />
  功    能：&lt;实现表横向聚合&gt;<br />
*/<br />
DECLARE @t TABLE(C1 int,C2 int,C3 int,C4 int,C5 int)<br />
INSERT INTO @t VALUES(1,2,6,3,4)<br />
INSERT INTO @t VALUES(2,2,3,4,5)<br />
INSERT INTO @t VALUES(0,3,6,2,8)

--查询<br />
SELECT *,<br />
    [min] = (<br />
        SELECT MIN(v) FROM(<br />
            SELECT v=A.C1 UNION SELECT v=A.C2 UNION SELECT v=A.C3 UNION SELECT v=A.C4 UNION SELECT v=A.C5<br />
        )B),<br />
    [max] = (<br />
        SELECT MAX(v) FROM(<br />
            SELECT v=A.C1 UNION SELECT v=A.C2 UNION SELECT v=A.C3 UNION SELECT v=A.C4 UNION SELECT v=A.C5<br />
        )B),<br />
    [count&gt;=5] = (<br />
        SELECT COUNT(*) FROM(<br />
            SELECT v=A.C1 UNION SELECT v=A.C2 UNION SELECT v=A.C3 UNION SELECT v=A.C4 UNION SELECT v=A.C5<br />
        )B WHERE v&gt;=5)<br />
FROM @t A</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>执行结果如下图所示:</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/403904/2012092910261495.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7g3v1q.html">&lbrack;SimHash&rsqb;  find the percentage of similarity between two given data</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8opxwpq.html">DBLINK 创建的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4r4n08.html">IC系统组成概论</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ygzpeq.html">算法提高 c&plus;&plus;&lowbar;ch02&lowbar;01</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1genx9.html">&lbrack;转&rsqb;Using the Group Pane to Repeat Page Titles</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1zoy59.html">Performance Optimization &lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okrgml9.html">POI HSSFColor 颜色索引对照表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmzjxq.html">BZOJ1621&colon; &lbrack;Usaco2008 Open&rsqb;Roads Around The Farm分岔路口</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn06ypq.html">POJ 1845</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlvdd9.html">关于String s &equals; new String&lpar;&amp;quot&semi;xyz&amp;quot&semi;&rpar;&semi; 创建几个对象的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yo60r8.html">Hibernate入门之配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey16ez9.html">copy算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rggo4e8.html">大约SQL&sol;NoSQL数据库搜索&sol;思考查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zomw13q.html">【原创】Linux基础之用户和组</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1g36zq.html">extundelete数据恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy2d639.html">pytest五：fixture&lowbar;autouse&equals;True</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j177d09.html">催希凡javaweb 学习28天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvmozk8.html">python遍历某一位置所有文件夹中的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o412d1q.html">java 发送post请求参数中含有&plus;会转化为空格的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjw35zq.html">linux文件系统 - 初始化&lpar;一&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96o2wo49.html">SecureCRT、FileZilla使用Public证书登录Linux</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mv6oeq.html">ios8新特性widget开发－b</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v0zjj8.html">自动发布工具版本从python2升级成python3后遇到的种种问题（涉及paramiko，Crypto，zipfile等等）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xl6mz8.html">使用ListItem给DropDownList填充数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mvpexq.html">关于&commat;synchronized&lpar;self&rpar;的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k163z59.html">win7&plus;ubuntu双系统安装方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1z0j79.html">Fail2ban用来作DDOS防守工具，不知够不够份量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm0e569.html">【POJ2396】Budget（上下界网络流）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z17or19.html">【HDOJ】2279 File Search Tool</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v5m148.html">详解Linux配置iSCSI方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
